Index: /trunk/sources/LibSVM/Model.cs
===================================================================
--- /trunk/sources/LibSVM/Model.cs	(revision 2414)
+++ /trunk/sources/LibSVM/Model.cs	(revision 2415)
@@ -21,406 +21,470 @@
 using System;
 using System.IO;
-
-namespace SVM {
-  /// <remarks>
-  /// Encapsulates an SVM Model.
-  /// </remarks>
-  [Serializable]
-  public class Model {
-    private Parameter _parameter;
-    private int _numberOfClasses;
-    private int _supportVectorCount;
-    private Node[][] _supportVectors;
-    private double[][] _supportVectorCoefficients;
-    private double[] _rho;
-    private double[] _pairwiseProbabilityA;
-    private double[] _pairwiseProbabilityB;
-
-    private int[] _classLabels;
-    private int[] _numberOfSVPerClass;
-
-    internal Model() {
-    }
-
+using System.Threading;
+using System.Globalization;
+
+namespace SVM
+{
     /// <summary>
-    /// Parameter object.
+    /// Encapsulates an SVM Model.
     /// </summary>
-    public Parameter Parameter {
-      get {
-        return _parameter;
-      }
-      set {
-        _parameter = value;
-      }
-    }
-
-    /// <summary>
-    /// Number of classes in the model.
-    /// </summary>
-    public int NumberOfClasses {
-      get {
-        return _numberOfClasses;
-      }
-      set {
-        _numberOfClasses = value;
-      }
-    }
-
-    /// <summary>
-    /// Total number of support vectors.
-    /// </summary>
-    public int SupportVectorCount {
-      get {
-        return _supportVectorCount;
-      }
-      set {
-        _supportVectorCount = value;
-      }
-    }
-
-    /// <summary>
-    /// The support vectors.
-    /// </summary>
-    public Node[][] SupportVectors {
-      get {
-        return _supportVectors;
-      }
-      set {
-        _supportVectors = value;
-      }
-    }
-
-    /// <summary>
-    /// The coefficients for the support vectors.
-    /// </summary>
-    public double[][] SupportVectorCoefficients {
-      get {
-        return _supportVectorCoefficients;
-      }
-      set {
-        _supportVectorCoefficients = value;
-      }
-    }
-
-    /// <summary>
-    /// Rho values.
-    /// </summary>
-    public double[] Rho {
-      get {
-        return _rho;
-      }
-      set {
-        _rho = value;
-      }
-    }
-
-    /// <summary>
-    /// First pairwise probability.
-    /// </summary>
-    public double[] PairwiseProbabilityA {
-      get {
-        return _pairwiseProbabilityA;
-      }
-      set {
-        _pairwiseProbabilityA = value;
-      }
-    }
-
-    /// <summary>
-    /// Second pairwise probability.
-    /// </summary>
-    public double[] PairwiseProbabilityB {
-      get {
-        return _pairwiseProbabilityB;
-      }
-      set {
-        _pairwiseProbabilityB = value;
-      }
-    }
-
-    // for classification only
-
-    /// <summary>
-    /// Class labels.
-    /// </summary>
-    public int[] ClassLabels {
-      get {
-        return _classLabels;
-      }
-      set {
-        _classLabels = value;
-      }
-    }
-
-    /// <summary>
-    /// Number of support vectors per class.
-    /// </summary>
-    public int[] NumberOfSVPerClass {
-      get {
-        return _numberOfSVPerClass;
-      }
-      set {
-        _numberOfSVPerClass = value;
-      }
-    }
-
-    /// <summary>
-    /// Reads a Model from the provided file.
-    /// </summary>
-    /// <param name="filename">The name of the file containing the Model</param>
-    /// <returns>the Model</returns>
-    public static Model Read(string filename) {
-      FileStream input = File.OpenRead(filename);
-      try {
-        return Read(input);
-      }
-      finally {
-        input.Close();
-      }
-    }
-
-    /// <summary>
-    /// Reads a Model from the provided stream.
-    /// </summary>
-    /// <param name="stream">The stream from which to read the Model.</param>
-    /// <returns>the Model</returns>
-    public static Model Read(Stream stream) {
-      StreamReader input = new StreamReader(stream);
-
-      // read parameters
-
-      Model model = new Model();
-      Parameter param = new Parameter();
-      model.Parameter = param;
-      model.Rho = null;
-      model.PairwiseProbabilityA = null;
-      model.PairwiseProbabilityB = null;
-      model.ClassLabels = null;
-      model.NumberOfSVPerClass = null;
-
-      bool headerFinished = false;
-      while (!headerFinished) {
-        string line = input.ReadLine();
-        string cmd, arg;
-        int splitIndex = line.IndexOf(' ');
-        if (splitIndex >= 0) {
-          cmd = line.Substring(0, splitIndex);
-          arg = line.Substring(splitIndex + 1);
-        } else {
-          cmd = line;
-          arg = "";
-        }
-        arg = arg.ToLower();
-
-        int i, n;
-        switch (cmd) {
-          case "svm_type":
-            param.SvmType = (SvmType)Enum.Parse(typeof(SvmType), arg.ToUpper());
-            break;
-
-          case "kernel_type":
-            param.KernelType = (KernelType)Enum.Parse(typeof(KernelType), arg.ToUpper());
-            break;
-
-          case "degree":
-            param.Degree = int.Parse(arg);
-            break;
-
-          case "gamma":
-            param.Gamma = double.Parse(arg);
-            break;
-
-          case "coef0":
-            param.Coefficient0 = double.Parse(arg);
-            break;
-
-          case "nr_class":
-            model.NumberOfClasses = int.Parse(arg);
-            break;
-
-          case "total_sv":
-            model.SupportVectorCount = int.Parse(arg);
-            break;
-
-          case "rho":
-            n = model.NumberOfClasses * (model.NumberOfClasses - 1) / 2;
-            model.Rho = new double[n];
-            string[] rhoParts = arg.Split();
-            for (i = 0; i < n; i++)
-              model.Rho[i] = double.Parse(rhoParts[i]);
-            break;
-
-          case "label":
-            n = model.NumberOfClasses;
-            model.ClassLabels = new int[n];
-            string[] labelParts = arg.Split();
-            for (i = 0; i < n; i++)
-              model.ClassLabels[i] = int.Parse(labelParts[i]);
-            break;
-
-          case "probA":
-            n = model.NumberOfClasses * (model.NumberOfClasses - 1) / 2;
-            model.PairwiseProbabilityA = new double[n];
-            string[] probAParts = arg.Split();
-            for (i = 0; i < n; i++)
-              model.PairwiseProbabilityA[i] = double.Parse(probAParts[i]);
-            break;
-
-          case "probB":
-            n = model.NumberOfClasses * (model.NumberOfClasses - 1) / 2;
-            model.PairwiseProbabilityB = new double[n];
-            string[] probBParts = arg.Split();
-            for (i = 0; i < n; i++)
-              model.PairwiseProbabilityB[i] = double.Parse(probBParts[i]);
-            break;
-
-          case "nr_sv":
-            n = model.NumberOfClasses;
-            model.NumberOfSVPerClass = new int[n];
-            string[] nrsvParts = arg.Split();
-            for (i = 0; i < n; i++)
-              model.NumberOfSVPerClass[i] = int.Parse(nrsvParts[i]);
-            break;
-
-          case "SV":
-            headerFinished = true;
-            break;
-
-          default:
-            throw new Exception("Unknown text in model file");
-        }
-      }
-
-      // read sv_coef and SV
-
-      int m = model.NumberOfClasses - 1;
-      int l = model.SupportVectorCount;
-      model.SupportVectorCoefficients = new double[m][];
-      for (int i = 0; i < m; i++) {
-        model.SupportVectorCoefficients[i] = new double[l];
-      }
-      model.SupportVectors = new Node[l][];
-
-      for (int i = 0; i < l; i++) {
-        string[] parts = input.ReadLine().Trim().Split();
-
-        for (int k = 0; k < m; k++)
-          model.SupportVectorCoefficients[k][i] = double.Parse(parts[k]);
-        int n = parts.Length - m;
-        model.SupportVectors[i] = new Node[n];
-        for (int j = 0; j < n; j++) {
-          string[] nodeParts = parts[m + j].Split(':');
-          model.SupportVectors[i][j] = new Node();
-          model.SupportVectors[i][j].Index = int.Parse(nodeParts[0]);
-          model.SupportVectors[i][j].Value = double.Parse(nodeParts[1]);
-        }
-      }
-
-      return model;
-    }
-
-    /// <summary>
-    /// Writes a model to the provided filename.  This will overwrite any previous data in the file.
-    /// </summary>
-    /// <param name="filename">The desired file</param>
-    /// <param name="model">The Model to write</param>
-    public static void Write(string filename, Model model) {
-      FileStream stream = File.Open(filename, FileMode.Create);
-      try {
-        Write(stream, model);
-      }
-      finally {
-        stream.Close();
-      }
-    }
-
-    /// <summary>
-    /// Writes a model to the provided stream.
-    /// </summary>
-    /// <param name="stream">The output stream</param>
-    /// <param name="model">The model to write</param>
-    public static void Write(Stream stream, Model model) {
-      StreamWriter output = new StreamWriter(stream);
-
-      Parameter param = model.Parameter;
-
-      output.Write("svm_type " + param.SvmType + Environment.NewLine);
-      output.Write("kernel_type " + param.KernelType + Environment.NewLine);
-
-      if (param.KernelType == KernelType.POLY)
-        output.Write("degree " + param.Degree + Environment.NewLine);
-
-      if (param.KernelType == KernelType.POLY || param.KernelType == KernelType.RBF || param.KernelType == KernelType.SIGMOID)
-        output.Write("gamma " + param.Gamma + Environment.NewLine);
-
-      if (param.KernelType == KernelType.POLY || param.KernelType == KernelType.SIGMOID)
-        output.Write("coef0 " + param.Coefficient0 + Environment.NewLine);
-
-      int nr_class = model.NumberOfClasses;
-      int l = model.SupportVectorCount;
-      output.Write("nr_class " + nr_class + Environment.NewLine);
-      output.Write("total_sv " + l + Environment.NewLine);
-
-      {
-        output.Write("rho");
-        for (int i = 0; i < nr_class * (nr_class - 1) / 2; i++)
-          output.Write(" " + model.Rho[i]);
-        output.Write(Environment.NewLine);
-      }
-
-      if (model.ClassLabels != null) {
-        output.Write("label");
-        for (int i = 0; i < nr_class; i++)
-          output.Write(" " + model.ClassLabels[i]);
-        output.Write(Environment.NewLine);
-      }
-
-      if (model.PairwiseProbabilityA != null)
-      // regression has probA only
-            {
-        output.Write("probA");
-        for (int i = 0; i < nr_class * (nr_class - 1) / 2; i++)
-          output.Write(" " + model.PairwiseProbabilityA[i]);
-        output.Write(Environment.NewLine);
-      }
-      if (model.PairwiseProbabilityB != null) {
-        output.Write("probB");
-        for (int i = 0; i < nr_class * (nr_class - 1) / 2; i++)
-          output.Write(" " + model.PairwiseProbabilityB[i]);
-        output.Write(Environment.NewLine);
-      }
-
-      if (model.NumberOfSVPerClass != null) {
-        output.Write("nr_sv");
-        for (int i = 0; i < nr_class; i++)
-          output.Write(" " + model.NumberOfSVPerClass[i]);
-        output.Write(Environment.NewLine);
-      }
-
-      output.Write("SV\n");
-      double[][] sv_coef = model.SupportVectorCoefficients;
-      Node[][] SV = model.SupportVectors;
-
-      for (int i = 0; i < l; i++) {
-        for (int j = 0; j < nr_class - 1; j++)
-          output.Write(sv_coef[j][i] + " ");
-
-        Node[] p = SV[i];
-        if (p.Length == 0) {
-          output.WriteLine();
-          continue;
-        }
-        if (param.KernelType == KernelType.PRECOMPUTED)
-          output.Write("0:{0}", (int)p[0].Value);
-        else {
-          output.Write("{0}:{1}", p[0].Index, p[0].Value);
-          for (int j = 1; j < p.Length; j++)
-            output.Write(" {0}:{1}", p[j].Index, p[j].Value);
-        }
-        output.WriteLine();
-      }
-
-      output.Flush();
-    }
-  }
+	[Serializable]
+	public class Model
+	{
+        private Parameter _parameter;
+        private int _numberOfClasses;
+        private int _supportVectorCount;
+        private Node[][] _supportVectors;
+        private double[][] _supportVectorCoefficients;
+        private double[] _rho;
+        private double[] _pairwiseProbabilityA;
+        private double[] _pairwiseProbabilityB;
+
+        private int[] _classLabels;
+        private int[] _numberOfSVPerClass;
+
+        internal Model()
+        {
+        }
+
+        /// <summary>
+        /// Parameter object.
+        /// </summary>
+        public Parameter Parameter
+        {
+            get
+            {
+                return _parameter;
+            }
+            set
+            {
+                _parameter = value;
+            }
+        }
+
+        /// <summary>
+        /// Number of classes in the model.
+        /// </summary>
+        public int NumberOfClasses
+        {
+            get
+            {
+                return _numberOfClasses;
+            }
+            set
+            {
+                _numberOfClasses = value;
+            }
+        }
+
+        /// <summary>
+        /// Total number of support vectors.
+        /// </summary>
+        public int SupportVectorCount
+        {
+            get
+            {
+                return _supportVectorCount;
+            }
+            set
+            {
+                _supportVectorCount = value;
+            }
+        }
+
+        /// <summary>
+        /// The support vectors.
+        /// </summary>
+        public Node[][] SupportVectors
+        {
+            get
+            {
+                return _supportVectors;
+            }
+            set
+            {
+                _supportVectors = value;
+            }
+        }
+
+        /// <summary>
+        /// The coefficients for the support vectors.
+        /// </summary>
+        public double[][] SupportVectorCoefficients
+        {
+            get
+            {
+                return _supportVectorCoefficients;
+            }
+            set
+            {
+                _supportVectorCoefficients = value;
+            }
+        }
+
+        /// <summary>
+        /// Rho values.
+        /// </summary>
+        public double[] Rho
+        {
+            get
+            {
+                return _rho;
+            }
+            set
+            {
+                _rho = value;
+            }
+        }
+
+        /// <summary>
+        /// First pairwise probability.
+        /// </summary>
+        public double[] PairwiseProbabilityA
+        {
+            get
+            {
+                return _pairwiseProbabilityA;
+            }
+            set
+            {
+                _pairwiseProbabilityA = value;
+            }
+        }
+
+        /// <summary>
+        /// Second pairwise probability.
+        /// </summary>
+        public double[] PairwiseProbabilityB
+        {
+            get
+            {
+                return _pairwiseProbabilityB;
+            }
+            set
+            {
+                _pairwiseProbabilityB = value;
+            }
+        }
+		
+		// for classification only
+
+        /// <summary>
+        /// Class labels.
+        /// </summary>
+        public int[] ClassLabels
+        {
+            get
+            {
+                return _classLabels;
+            }
+            set
+            {
+                _classLabels = value;
+            }
+        }
+
+        /// <summary>
+        /// Number of support vectors per class.
+        /// </summary>
+        public int[] NumberOfSVPerClass
+        {
+            get
+            {
+                return _numberOfSVPerClass;
+            }
+            set
+            {
+                _numberOfSVPerClass = value;
+            }
+        }
+
+        /// <summary>
+        /// Reads a Model from the provided file.
+        /// </summary>
+        /// <param name="filename">The name of the file containing the Model</param>
+        /// <returns>the Model</returns>
+        public static Model Read(string filename)
+        {
+            FileStream input = File.OpenRead(filename);
+            try
+            {
+                return Read(input);
+            }
+            finally
+            {
+                input.Close();
+            }
+        }
+
+        /// <summary>
+        /// Reads a Model from the provided stream.
+        /// </summary>
+        /// <param name="stream">The stream from which to read the Model.</param>
+        /// <returns>the Model</returns>
+        public static Model Read(Stream stream)
+        {
+            TemporaryCulture.Start();
+
+            StreamReader input = new StreamReader(stream);
+
+            // read parameters
+
+            Model model = new Model();
+            Parameter param = new Parameter();
+            model.Parameter = param;
+            model.Rho = null;
+            model.PairwiseProbabilityA = null;
+            model.PairwiseProbabilityB = null;
+            model.ClassLabels = null;
+            model.NumberOfSVPerClass = null;
+
+            bool headerFinished = false;
+            while (!headerFinished)
+            {
+                string line = input.ReadLine();
+                string cmd, arg;
+                int splitIndex = line.IndexOf(' ');
+                if (splitIndex >= 0)
+                {
+                    cmd = line.Substring(0, splitIndex);
+                    arg = line.Substring(splitIndex + 1);
+                }
+                else
+                {
+                    cmd = line;
+                    arg = "";
+                }
+                arg = arg.ToLower();
+
+                int i,n;
+                switch(cmd){
+                    case "svm_type":
+                        param.SvmType = (SvmType)Enum.Parse(typeof(SvmType), arg.ToUpper());
+                        break;
+                        
+                    case "kernel_type":
+                        param.KernelType = (KernelType)Enum.Parse(typeof(KernelType), arg.ToUpper());
+                        break;
+
+                    case "degree":
+                        param.Degree = int.Parse(arg);
+                        break;
+
+                    case "gamma":
+                        param.Gamma = double.Parse(arg);
+                        break;
+
+                    case "coef0":
+                        param.Coefficient0 = double.Parse(arg);
+                        break;
+
+                    case "nr_class":
+                        model.NumberOfClasses = int.Parse(arg);
+                        break;
+
+                    case "total_sv":
+                        model.SupportVectorCount = int.Parse(arg);
+                        break;
+
+                    case "rho":
+                        n = model.NumberOfClasses * (model.NumberOfClasses - 1) / 2;
+                        model.Rho = new double[n];
+                        string[] rhoParts = arg.Split();
+                        for(i=0; i<n; i++)
+                            model.Rho[i] = double.Parse(rhoParts[i]);
+                        break;
+
+                    case "label":
+                        n = model.NumberOfClasses;
+                        model.ClassLabels = new int[n];
+                        string[] labelParts = arg.Split();
+                        for (i = 0; i < n; i++)
+                            model.ClassLabels[i] = int.Parse(labelParts[i]);
+                        break;
+
+                    case "probA":
+                        n = model.NumberOfClasses * (model.NumberOfClasses - 1) / 2;
+                        model.PairwiseProbabilityA = new double[n];
+                            string[] probAParts = arg.Split();
+                        for (i = 0; i < n; i++)
+                            model.PairwiseProbabilityA[i] = double.Parse(probAParts[i]);
+                        break;
+
+                    case "probB":
+                        n = model.NumberOfClasses * (model.NumberOfClasses - 1) / 2;
+                        model.PairwiseProbabilityB = new double[n];
+                        string[] probBParts = arg.Split();
+                        for (i = 0; i < n; i++)
+                            model.PairwiseProbabilityB[i] = double.Parse(probBParts[i]);
+                        break;
+
+                    case "nr_sv":
+                        n = model.NumberOfClasses;
+                        model.NumberOfSVPerClass = new int[n];
+                        string[] nrsvParts = arg.Split();
+                        for (i = 0; i < n; i++)
+                            model.NumberOfSVPerClass[i] = int.Parse(nrsvParts[i]);
+                        break;
+
+                    case "SV":
+                        headerFinished = true;
+                        break;
+
+                    default:
+                        throw new Exception("Unknown text in model file");  
+                }
+            }
+
+            // read sv_coef and SV
+
+            int m = model.NumberOfClasses - 1;
+            int l = model.SupportVectorCount;
+            model.SupportVectorCoefficients = new double[m][];
+            for (int i = 0; i < m; i++)
+            {
+                model.SupportVectorCoefficients[i] = new double[l];
+            }
+            model.SupportVectors = new Node[l][];
+
+            for (int i = 0; i < l; i++)
+            {
+                string[] parts = input.ReadLine().Trim().Split();
+
+                for (int k = 0; k < m; k++)
+                    model.SupportVectorCoefficients[k][i] = double.Parse(parts[k]);
+                int n = parts.Length-m;
+                model.SupportVectors[i] = new Node[n];
+                for (int j = 0; j < n; j++)
+                {
+                    string[] nodeParts = parts[m + j].Split(':');
+                    model.SupportVectors[i][j] = new Node();
+                    model.SupportVectors[i][j].Index = int.Parse(nodeParts[0]);
+                    model.SupportVectors[i][j].Value = double.Parse(nodeParts[1]);
+                }
+            }
+
+            TemporaryCulture.Stop();
+
+            return model;
+        }
+
+        /// <summary>
+        /// Writes a model to the provided filename.  This will overwrite any previous data in the file.
+        /// </summary>
+        /// <param name="filename">The desired file</param>
+        /// <param name="model">The Model to write</param>
+        public static void Write(string filename, Model model)
+        {
+            FileStream stream = File.Open(filename, FileMode.Create);
+            try
+            {
+                Write(stream, model);
+            }
+            finally
+            {
+                stream.Close();
+            }
+        }
+
+        /// <summary>
+        /// Writes a model to the provided stream.
+        /// </summary>
+        /// <param name="stream">The output stream</param>
+        /// <param name="model">The model to write</param>
+        public static void Write(Stream stream, Model model)
+        {
+            TemporaryCulture.Start();
+
+            StreamWriter output = new StreamWriter(stream);
+
+            Parameter param = model.Parameter;
+
+            output.Write("svm_type " + param.SvmType + "\n");
+            output.Write("kernel_type " + param.KernelType + "\n");
+
+            if (param.KernelType == KernelType.POLY)
+                output.Write("degree " + param.Degree + "\n");
+
+            if (param.KernelType == KernelType.POLY || param.KernelType == KernelType.RBF || param.KernelType == KernelType.SIGMOID)
+                output.Write("gamma " + param.Gamma + "\n");
+
+            if (param.KernelType == KernelType.POLY || param.KernelType == KernelType.SIGMOID)
+                output.Write("coef0 " + param.Coefficient0 + "\n");
+
+            int nr_class = model.NumberOfClasses;
+            int l = model.SupportVectorCount;
+            output.Write("nr_class " + nr_class + "\n");
+            output.Write("total_sv " + l + "\n");
+
+            {
+                output.Write("rho");
+                for (int i = 0; i < nr_class * (nr_class - 1) / 2; i++)
+                    output.Write(" " + model.Rho[i]);
+                output.Write("\n");
+            }
+
+            if (model.ClassLabels != null)
+            {
+                output.Write("label");
+                for (int i = 0; i < nr_class; i++)
+                    output.Write(" " + model.ClassLabels[i]);
+                output.Write("\n");
+            }
+
+            if (model.PairwiseProbabilityA != null)
+            // regression has probA only
+            {
+                output.Write("probA");
+                for (int i = 0; i < nr_class * (nr_class - 1) / 2; i++)
+                    output.Write(" " + model.PairwiseProbabilityA[i]);
+                output.Write("\n");
+            }
+            if (model.PairwiseProbabilityB != null)
+            {
+                output.Write("probB");
+                for (int i = 0; i < nr_class * (nr_class - 1) / 2; i++)
+                    output.Write(" " + model.PairwiseProbabilityB[i]);
+                output.Write("\n");
+            }
+
+            if (model.NumberOfSVPerClass != null)
+            {
+                output.Write("nr_sv");
+                for (int i = 0; i < nr_class; i++)
+                    output.Write(" " + model.NumberOfSVPerClass[i]);
+                output.Write("\n");
+            }
+
+            output.Write("SV\n");
+            double[][] sv_coef = model.SupportVectorCoefficients;
+            Node[][] SV = model.SupportVectors;
+
+            for (int i = 0; i < l; i++)
+            {
+                for (int j = 0; j < nr_class - 1; j++)
+                    output.Write(sv_coef[j][i] + " ");
+
+                Node[] p = SV[i];
+                if (p.Length == 0)
+                {
+                    output.WriteLine();
+                    continue;
+                }
+                if (param.KernelType == KernelType.PRECOMPUTED)
+                    output.Write("0:{0}", (int)p[0].Value);
+                else
+                {
+                    output.Write("{0}:{1}", p[0].Index, p[0].Value);
+                    for (int j = 1; j < p.Length; j++)
+                        output.Write(" {0}:{1}", p[j].Index, p[j].Value);
+                }
+                output.WriteLine();
+            }
+
+            output.Flush();
+
+            TemporaryCulture.Stop();
+        }
+	}
 }
Index: /trunk/sources/LibSVM/Node.cs
===================================================================
--- /trunk/sources/LibSVM/Node.cs	(revision 2414)
+++ /trunk/sources/LibSVM/Node.cs	(revision 2415)
@@ -22,13 +22,13 @@
 namespace SVM
 {
-    /// <remarks>
+    /// <summary>
     /// Encapsulates a node in a Problem vector, with an index and a value (for more efficient representation
     /// of sparse data.
-    /// </remarks>
+    /// </summary>
 	[Serializable]
 	public class Node : IComparable<Node>
 	{
-        private int _index;
-        private double _value;
+        internal int _index;
+        internal double _value;
 
         /// <summary>
Index: /trunk/sources/LibSVM/Parameter.cs
===================================================================
--- /trunk/sources/LibSVM/Parameter.cs	(revision 2414)
+++ /trunk/sources/LibSVM/Parameter.cs	(revision 2415)
@@ -19,10 +19,12 @@
 
 using System;
+using System.Linq;
+using System.Collections.Generic;
 
 namespace SVM
 {
-    /// <remarks>
+    /// <summary>
     /// Contains all of the types of SVM this library can model.
-    /// </remarks>
+    /// </summary>
     public enum SvmType { 
         /// <summary>
@@ -47,7 +49,7 @@
         NU_SVR 
     };
-    /// <remarks>
+    /// <summary>
     /// Contains the various kernel types this library can use.
-    /// </remarks>
+    /// </summary>
     public enum KernelType { 
         /// <summary>
@@ -73,9 +75,9 @@
     };
 
-    /// <remarks>
+    /// <summary>
     /// This class contains the various parameters which can affect the way in which an SVM
     /// is learned.  Unless you know what you are doing, chances are you are best off using
     /// the default values.
-    /// </remarks>
+    /// </summary>
 	[Serializable]
 	public class Parameter : ICloneable
@@ -91,7 +93,5 @@
         private double _eps;
 
-        private int _weightCount;
-        private int[] _weightLabels;
-        private double[] _weights;
+        private Dictionary<int, double> _weights;
         private double _nu;
         private double _p;
@@ -116,7 +116,5 @@
             _shrinking = true;
             _probability = false;
-            _weightCount = 0;
-            _weightLabels = new int[0];
-            _weights = new double[0];
+            _weights = new Dictionary<int, double>();
         }
 
@@ -234,46 +232,15 @@
             }
         }
-        /// <summary>
-        /// Number of weights.
-        /// </summary>
-        public int WeightCount
-        {
-            get
-            {
-                return _weightCount;
-            }
-            set
-            {
-                _weightCount = value;
-            }
-        }
-        /// <summary>
-        /// Array of indicies corresponding to the Weights array (for C-SVC)
-        /// </summary>
-        public int[] WeightLabels
-        {
-            get
-            {
-                return _weightLabels;
-            }
-            set
-            {
-                _weightLabels = value;
-            }
-        }
-        /// <summary>
-        /// The parameter C of class i to weight*C in C-SVC (default 1)
-        /// </summary>
-        public double[] Weights
-        {
-            get
-            {
+
+        /// <summary>
+        /// Contains custom weights for class labels.  Default weight value is 1.
+        /// </summary>
+        public Dictionary<int,double> Weights
+        {
+            get{
                 return _weights;
             }
-            set
-            {
-                _weights = value;
-            }
-        }
+        }
+
         /// <summary>
         /// The parameter nu of nu-SVC, one-class SVM, and nu-SVR (default 0.5)
